clear all

disp ("Hello")

function F = trans_fnc(x,p) % 
 if nargin~=2
    error("This function is waiting for 2 arguments")
 end
 	
 ls = p(1);    % in um
 la = p(2);    % in um
 offset = 0.0;
 c=0.3;        %speed of light in um/fs
 n1 = 1.05;    % average refractive index
 n2 = 1;
 R =((n1-n2)/(n1+n2))^2;
 z0 = (2/3)*ls*(1+R)/(1-R);
 ze = (la/2)*log((1+(1/la)*z0)/(1-(1/la)*z0));
 zp = ze;
 %% model function:
 F =1.0./( (la/ze)*sinh((zp+ze)/la)*sinh(ze/la)./sinh(((x+offset)+2*ze)/la)); % inverse transmittance
end

f1=load ("TvL_60g_4.dat");
  
lambda = f1(:,1) ;
nr=size(f1,1);
nc=size(f1,2)-1;
T=f1(:,2:nc+1);
x= [0.84 1.28 1.44 1.64 1.71 1.84 1.87 1.95 2.17 2.31 2.56 2.76 2.87 2.90 3.00 3.41 4.32 4.88 5.49];

x_remove = [1.44 1.64 1.71 1.84 1.87 1.95 2.17];
[x, n] = setdiff (x, x_remove);
T = T(:,n);
nc = size (x, 2);

tolerance = .000001;
max_iterations = 1000;
weights = ones (1, nc);
dp = [.0001; .0001]; % bidirectional numeric gradient stepsize
dFdp = "dfdp"; % function for gradient (numerical)
weights = ones (1, nc);
pin = [0.1 3];% ls;la
options.bounds=[0.0001 10;0.001 100];
for i=1:nr  % i is the LAMBDA VARIABLE
 	y=1./T(i,:);
 	%% start leasqr, be sure that "verbose" is not set
 	global verbose; verbose = false;
 	[f, p] = leasqr (x, y, pin, "trans_fnc", tolerance, max_iterations, weights, dp, dFdp, options);
 	ls(i) = p(1); 
 	la(i) = p(2); 
 	fit(i,:) = f;
end 

p

